﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.Editors;

namespace WpfApplication2
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        TestClass t = new TestClass() { Val = 500 };
        public MainWindow()
        {
            InitializeComponent();

            this.DataContext = t;
        }

        private void xamNum_PreviewKeyDown_1(object sender, KeyEventArgs e)
        {
            if ( e.Key == Key.Enter )
            {
                BindingExpression b = xamNum.GetBindingExpression(XamNumericEditor.ValueProperty);
                if (xamNum.ValueConstraint.Validate(xamNum.Value, typeof(double)))
                {
                  b.UpdateSource();
                  MessageBox.Show("Source value is: " + t.Val);
                }
                else
                {
                  double max = Convert.ToDouble(xamNum.ValueConstraint.MaxInclusive);
                  double min = Convert.ToDouble(xamNum.ValueConstraint.MinInclusive);
                  double val = (double)xamNum.Value;

                  if (val < min)
                  {
                    xamNum.Value = min;
                  }

                  if (val > max)
                  {
                    xamNum.Value = max;
                  }

                  b.UpdateSource();
                  MessageBox.Show("Source value is: " + t.Val);
                }
            }
        }

        private void xamNum_PreviewMouseWheel_1(object sender, MouseWheelEventArgs e)
        {
            if (e.Delta < 0)
                xamNum.ExecuteCommand(MaskedEditorCommands.SpinDown);
            if (e.Delta > 0)
                xamNum.ExecuteCommand(MaskedEditorCommands.SpinUp);
        }
    }

    public class TestClass
    {
        public double Val
        { get; set; }
    }


}
